ru.bitel.bgbilling.modules.vidimax.common.service

## Interface VidimaxService

-     public interface VidimaxService

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.util.List<VidimaxTariff>` | `activeTariffList(int contractId, boolean tv)` Запрос на получение активных тарифных планов, с сервера пойдет запрос к видимаксу, так как у нас этих данных нет.
    `java.util.List<VidimaxCharge>` | `chargeList(int contractId, Period period, Page page, javax.xml.ws.Holder<java.math.BigDecimal> holderTotalSum)` Получение списка расходов по договору.
    `VidimaxClientPairData` | `clientPairDataGet(int contractId)` Получить пользовательские данные.
    `void` | `deleteClientPairData(int contractId)` Удаление пользовательских данных.
    `java.util.List<Charge>` | `getTransactions(int contractId, Period period)`
    `MapHolder<java.lang.Integer,IdTitle>` | `serviceMap()` Получить мап, где в качестве ключа выступает код услуги видимакса(идет в расходе видимакса), а значение IdTitle где в свою очередь id - это код услуги биллинги на который будет вешаться расход видимакса, а title - описание.
    `MapHolder<java.lang.Integer,java.lang.String>` | `tariffMap()` Получить мап с их названием.
    `java.util.List<IdTitle>` | `tariffsForPair()`
    `void` | `updateClientPairData(VidimaxClientPairData pairData)` Обновление/создание пользовательских данных.

- - ### Method Detail

    - #### getTransactions

          java.util.List<Charge> getTransactions(int contractId,
                                                 Period period)
                                          throws ru.bitel.bgbilling.common.BGException

      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### chargeList

          java.util.List<VidimaxCharge> chargeList(int contractId,
                                                   Period period,
                                                   Page page,
                                                   javax.xml.ws.Holder<java.math.BigDecimal> holderTotalSum)
                                            throws ru.bitel.bgbilling.common.BGException

      Получение списка расходов по договору.
      !! Важно !! не стоит передавать page, если выборка производится не по месячно, передавайте null.
      Parameters:
        `contractId` - - код договора.
        `period` - - за какой период.
        `holderTotalSum` - - содержит общую сумму всех расходов.
        `page` - - только для месячного периода.
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### clientPairDataGet

          VidimaxClientPairData clientPairDataGet(int contractId)
                                           throws ru.bitel.bgbilling.common.BGException

      Получить пользовательские данные.
      Parameters:
        `contractId` - - код договора.
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### updateClientPairData

          void updateClientPairData(VidimaxClientPairData pairData)
                             throws ru.bitel.bgbilling.common.BGException,
                                    ru.bitel.bgbilling.common.BGMessageException

      Обновление/создание пользовательских данных.
      Parameters:
        `pairData` -
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException`

    - #### deleteClientPairData

          void deleteClientPairData(int contractId)
                             throws ru.bitel.bgbilling.common.BGException,
                                    ru.bitel.bgbilling.common.BGMessageException

      Удаление пользовательских данных.
      Parameters:
        `contractId` - - код договора.
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException` - - если договор связанный.

    - #### activeTariffList

          java.util.List<VidimaxTariff> activeTariffList(int contractId,
                                                         boolean tv)
                                                  throws ru.bitel.bgbilling.common.BGException,
                                                         ru.bitel.bgbilling.common.BGMessageException

      Запрос на получение активных тарифных планов, с сервера пойдет запрос к видимаксу, так как у нас этих данных нет.
      Parameters:
        `contractId` - - код договора.
        `tv` - - если true, то тарифы тв, иначе тарифы видео по заказу
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `ru.bitel.bgbilling.common.BGMessageException` - - - если данный договор не связан.

    - #### tariffsForPair

          java.util.List<IdTitle> tariffsForPair()
                                          throws ru.bitel.bgbilling.common.BGException

      Returns:
        - список тарифов для выбора абоненту до связывания.
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### serviceMap

          MapHolder<java.lang.Integer,IdTitle> serviceMap()
                                                   throws ru.bitel.bgbilling.common.BGException

      Получить мап, где в качестве ключа выступает код услуги видимакса(идет в расходе видимакса), а значение IdTitle где в свою очередь id - это код услуги биллинги на который будет вешаться расход видимакса, а title - описание.
      Если для соответсвующей услуги видимакса в конфиге не был установлен его личная наработка, то установится дефолтное значение, если и ее нет в конфиге то -1. Если в конфиге не установлен title, то установится строка - код услуги видимакса. Мап может вообще не содержать услуг-у/и , если они не прописаны в конфиге.
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### tariffMap

          MapHolder<java.lang.Integer,java.lang.String> tariffMap()
                                                           throws ru.bitel.bgbilling.common.BGException

      Получить мап с их названием. Ключем является код тарифа видимакса.
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`